Subject: Co-existing XDP generic and native mode? (Re: [PATCH bpf-next v5 5/8] xdp: Provide extack messages when prog attachment failed)

From: Jesper Dangaard Brouer <[email-masked]>
Date: Fri, 1 Feb 2019 08:02:36 +0100

On Thu, 31 Jan 2019 19:11:01 -0800
Jakub Kicinski <[email-masked]> wrote:

> On Fri,  1 Feb 2019 01:19:51 +0100, Maciej Fijalkowski wrote:
> >  		if (__dev_xdp_query(dev, bpf_chk, XDP_QUERY_PROG) ||
> > -		    __dev_xdp_query(dev, bpf_chk, XDP_QUERY_PROG_HW))
> > +		    __dev_xdp_query(dev, bpf_chk, XDP_QUERY_PROG_HW)) {
> > +			NL_SET_ERR_MSG(extack, "native and generic XDP can't be active at the same time");
> >  			return -EEXIST;
> > +		}  
> 
> This reminds me, since we allowed native/driver and offloaded XDP
> programs to coexist in a25717d2b604 ("xdp: support simultaneous 
> driver and hw XDP attachment") I got an internal feature request 
> to also allow generic and native mode.  Would anyone object to that?

Well, I will object ;-)

I have two refactor ideas [1] and [2], that depend on not allowing
XDP-native and XDP-generic to co-exist.   The general idea is to let
XDP-native use the same fields in net_device->rx[] as XDP-generic given
they (currently) cannot co-exist. 
 The goal is (1) to move stuff out of driver code, and (2) hopefully
make it easier to implement per RXq XDP progs.

These are only refactor ideas, so if you can argue why your internal
feature request for simultaneous generic and native make more sense,
then I'm open for allowing this ?

[1] https://github.com/xdp-project/xdp-project/blob/master/areas/core/xdp_per_rxq01.org#refactor-idea-move-xdp_rxq_info-to-net_devicenetdev_rx_queue

[2] https://github.com/xdp-project/xdp-project/blob/master/areas/core/xdp_per_rxq01.org#refactor-idea-xdpbpf_prog-into-netdev_rx_queuenet_device

> Apart from a touch up to test_offload.py I don't think anything 
> would care.  netlink can already carry multiple IDs, iproute2
> understands it, too..

And we did notice you added support for HW+native:
 [3] https://github.com/xdp-project/xdp-project/blob/master/areas/core/xdp_per_rxq01.org
-- 
Best regards,
  Jesper Dangaard Brouer
  MSc.CS, Principal Kernel Engineer at Red Hat
  LinkedIn: http://www.linkedin.com/in/brouer